# Купа (структура даних)

У комп'ютерних науках купа - це спеціалізована структура даних на кшталт дерева, яка задовольняє властивості купи:
якщо B є вузлом-нащадком вузла A, то ключ (A) ≥ ключ (B). З цього випливає, що елемент із найбільшим ключем завжди
є кореневим вузлом купи, тому іноді такі купи називають max-купами.

![MaxHeap](./images/max-heap.jpeg)

![Array Representation](./images/array-representation.jpeg)

Якщо порівняння перевернути, то найменший елемент завжди буде кореневим вузлом, такі купи називають min-купами.

![MinHeap](./images/min-heap.jpeg)

*Made with [okso.app](https://okso.app)*

Не існує жодних обмежень щодо того, скільки вузлів-нащадків має кожен вузол купи. На практиці їх
число зазвичай трохи більше двох. Купа є максимально ефективною реалізацією абстрактного типу даних, який
називається чергою із пріоритетом.

Вузол на вершині купи, який не має батьків, називається кореневим вузлом.

## Посилання

- [Wikipedia](https://uk.wikipedia.org/wiki/%D0%9A%D1%83%D0%BF%D0%B0_(%D1%81%D1%82%D1%80%D1%83%D0%BA%D1%82%D1%83%D1%80%D0%B0_%D0%B4%D0%B0%D0%BD%D0%B8%D1%85))
